//############################################################################
//
// LaserBoy !!!
//
// by James Lehman
// Extra Stimulus Inc.
// james@akrobiz.com
//
// began: October 2003
//
// Copyright 2003, 2004, 2005, 2006, 2007, 2008, 2009 James Lehman.
// This source is distributed under the terms of the GNU General Public License.
//
// LaserBoy_TUI.hpp is part of LaserBoy.
//
// LaserBoy is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// LaserBoy is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with LaserBoy. If not, see <http://www.gnu.org/licenses/>.
//
//############################################################################
#ifndef __LASERBOY_TEXT_overlay_DEFINITIONS__
#define __LASERBOY_TEXT_overlay_DEFINITIONS__

#include "LaserBoy_space.hpp"

//############################################################################
class LaserBoy_GUI_base;

//############################################################################
class LaserBoy_TUI : public LaserBoy_space
{
public:
    LaserBoy_TUI(LaserBoy_GUI_base* gui)
                          : LaserBoy_space(gui)     {}
    //------------------------------------------------------------------------
virtual
   ~LaserBoy_TUI()   {};
    //------------------------------------------------------------------------
    void    render_space                    ();
    void    overlay_palettes                ();
    void    overlay_frame_stats             ();
    void    overlay_frame_set_stats         ();
    void    overlay_palette_set_stats       ();
    void    overlay_program_menu            ();
    void    overlay_please_wait             ();
    void    overlay_in_file_type_menu       ();
    void    overlay_in_ild_action_menu      ();
    void    overlay_in_dxf_action_menu      ();
    void    overlay_in_wave_action_menu     ();
    void    overlay_in_txt_action_menu      ();
    void    overlay_in_bmp_action_menu      ();
    void    overlay_if_not_z_options        ();
    void    overlay_in_pal_action_menu      ();
    void    overlay_out_file_type_menu      ();
    void    overlay_out_ild_menu            ();
    void    overlay_out_dxf_menu            ();
    void    overlay_out_wav_menu            ();
    void    overlay_out_txt_menu            ();
    void    overlay_out_bmp_menu            ();
    void    overlay_settings_menu           ();
    void    overlay_veiw_menu               ();
    void    overlay_visuals_menu            ();
    void    overlay_palette_tranz_menu      ();
    void    overlay_frame_set_tranz_menu    ();
    void    overlay_frame_tranz_menu        ();
    void    overlay_draw_color_blank_menu   ();
    void    overlay_move_scale_rotate_menu  ();
    void    overlay_wave_utilities_menu     ();
    void    overlay_show_wave_options_menu  ();
    void    overlay_wave_show_settings_menu ();
    //------------------------------------------------------------------------
    bool    overlay_wave_stats              (string file_name);
    short   overlay_wave_signal_polarities  (string file_name, int polarity[8]);
    void    overlay_wave_offsets            ();
    void    overlay_bit_resolution_settings ();
    void    overlay_file_list               (string directory);
    void    overlay_directory_list          (string directory);
    void    overlay_frame_effects           ();
    void    overlay_frame_set_effects       ();
    //------------------------------------------------------------------------
    LaserBoy_TUI& operator = (const LaserBoy_frame_set& frames)
                    {
                        LaserBoy_frame_set::clear();
                        LaserBoy_frame_set::reserve(frames.number_of_frames());
                        LaserBoy_frame_set::insert (LaserBoy_frame_set::end(),
                                                    frames.LaserBoy_frame_set::begin(),
                                                    frames.LaserBoy_frame_set::end()
                                                   );
                        renumber();
                        return *this;
                    }
    //------------------------------------------------------------------------
    u_int next_hue()
    {
        static int i = 0;
        switch(i++ % 12)
        {
            case  0:
                return bmp.make_rgb(255,0,0);
            case  1:
                return bmp.make_rgb(255,128,0);
            case  2:
                return bmp.make_rgb(255,255,0);
            case  3:
                return bmp.make_rgb(128,255,0);
            case  4:
                return bmp.make_rgb(0,255,0);
            case  5:
                return bmp.make_rgb(0,255,128);
            case  6:
                return bmp.make_rgb(0,255,255);
            case  7:
                return bmp.make_rgb(0,128,255);
            case  8:
                return bmp.make_rgb(0,0,255);
            case  9:
                return bmp.make_rgb(128,0,255);
            case 10:
                return bmp.make_rgb(255,0,255);
            case 11:
                return bmp.make_rgb(255,0,128);
        }
        return 0;
    }
    //------------------------------------------------------------------------
    string TUI_clue;
};

//############################################################################
#endif

//############################################################################
//////////////////////////////////////////////////////////////////////////////
//############################################################################
